require "circular_linked_list/version"

module CircularLinkedList
  # Your code goes here...
class Node
  attr_accessor :prev_node, :next_node, :node_value

  def initialize node_value
    @node_value = node_value
    @prev_node = self
    @next_node = self
  end 
end

class CircularLinkedList
  @@list_ref = nil
#  def initialoze(list_ref=nil)
 #   @@list_ref = list_ref
  #end

  def self.print_list
    puts "List contains:"
    if @@list_ref == nil
      puts "empty"
    elsif @@list_ref.next_node == nil
      puts @@list_ref.node_value
    else
      first_node = @@list_ref
      puts first_node.node_value

      node = @@list_ref.next_node
      while node != first_node
        puts node.node_value
        node = node.next_node
      end
    end
  end

  def self.add(value)
    new_node = Node.new value
    
    if @@list_ref == nil
      @@list_ref = new_node      
      puts "This node is added: #{@@list_ref.node_value}"
    elsif @@list_ref.next_node == @@list_ref
      new_node.prev_node = @@list_ref
      new_node.next_node = @@list_ref

      @@list_ref.next_node = new_node
      @@list_ref.prev_node = new_node

      @@list_ref = new_node
      puts "This node is added: #{@@list_ref.node_value}"
    else
      last = @@list_ref.next_node
     
      new_node.prev_node = @@list_ref
      new_node.next_node = last
      @@list_ref.next_node = new_node
      last.prev_node = new_node
      
      @@list_ref = new_node
      puts "This node is added: #{@@list_ref.node_value}"
    end  
  end

  def self.remove()
    if @@list_ref == nil
       puts "nothing to remove" 
    elsif @@list_ref.next_node == @@list_ref
       puts "This node is removed: #{@@list_ref.node_value}"
       @@list_ref = nil
    else
      @@list_ref.prev_node.next_node = @@list_ref.next_node
      @@list_ref.next_node.prev_node = @@list_ref.prev_node

      puts "This node is removed: #{@@list_ref.node_value}"
      @@list_ref = @@list_ref.prev_node
    end
  end

  def self.is_exists(value)
    if @@list_ref == nil
      puts "no"
    elsif @@list_ref.next_node == nil
      if @@list_ref.node_value == value
        puts "yes" 
      else
        puts "no"
      end
    else
      first_node = @@list_ref
      flag = 0
      node = @@list_ref.next_node
      while node != first_node
        if node.node_value == value
          flag = 1
          puts "yes" 
          break
        end
        node = node.next_node
      end
      puts "no" if flag == 0
    end
  end
end

while 1 do
 puts "1. add"
 puts "2. remove"
 puts "3. is exists"
 puts "4. print list"
 puts "5. exit"
 choice = gets.to_i
 case(choice)
 when 1 
	   puts "Enter the value:"
           value = gets
           #value = value.to_i
           CircularLinkedList.add(value)
 when 2 
           CircularLinkedList.remove
 when 3 
	   puts "Enter the value:"
           value = gets
	   #value = value.to_i
           CircularLinkedList.is_exists value
 when 4 
	   CircularLinkedList.print_list
 when 5 
           exit(0)
 else 
	   puts "Wrong choice" 
 end
end
end
